<script setup lang="ts">
    import { computed } from 'vue'
    import { ButtonAction } from '../entities/ButtonAction'
    import SActionButton from '@/shared/button/components/SActionButton.vue'

    interface Props {
        icon: string
        buttonActions: ButtonAction[]
        display?: 'inline' | 'floating-absolute' | 'floating-fixed'
        floatingPosition?: 'left' | 'right'
        dataCy?: string
    }
    const props = withDefaults(defineProps<Props>(), {
        floatingPosition: 'right',
        display: 'inline',
        dataCy: undefined,
    })
    const fabPosition = computed(() => {
        return {
            left: props.floatingPosition === 'left' ? '25px' : 'initial',
            right: props.floatingPosition === 'right' ? '25px' : 'initial',
        }
    })
</script>

<template>
    <s-action-button
        v-if="buttonActions.length === 1"
        :data-cy="dataCy"
        :icon="icon"
        :label="buttonActions[0].shortLabel ?? buttonActions[0].label"
        :to="buttonActions[0].route"
        :display="display"
        :position="floatingPosition"
    />
    <v-bottom-sheet v-if="buttonActions.length > 1" :data-cy="dataCy">
        <template #activator="{ props: activatorProps }">
            <v-btn
                v-bind="activatorProps"
                :class="{
                    'floating-fixed': display === 'floating-fixed',
                    'floating-absolute': display === 'floating-absolute',
                }"
                :icon="icon"
                :style="
                    ['floating-fixed', 'floating-absolute'].includes(display)
                        ? fabPosition
                        : undefined
                "
            ></v-btn>
        </template>

        <v-list>
            <v-list-item
                v-for="buttonAction in buttonActions"
                :key="buttonAction.route.toString()"
                :prepend-icon="buttonAction.icon"
                :title="buttonAction.label"
                :to="buttonAction.route"
            ></v-list-item>
        </v-list>
    </v-bottom-sheet>
</template>
<style scoped lang="scss">
    .floating-fixed {
        position: fixed;
        right: 25px;
        bottom: 25px;
        z-index: 1001;
    }
    .floating-absolute {
        position: absolute;
        right: 25px;
        bottom: 25px;
        z-index: 1001;
    }
</style>
